/*
 * Copyright (C) 2013 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <QtCore/QCoreApplication>
#include <QtCore/QDir>
#include <QtCore/QString>

static QString SNAP_ENV = qgetenv("SNAP");
static QString APP_DIR = qgetenv("APP_DIR");

inline bool isClick() {
    static bool click = !APP_DIR.isEmpty();
    return click;
}

inline bool isRunningInstalled()
{
    static bool installed = (QCoreApplication::applicationDirPath().startsWith("@CMAKE_INSTALL_FULL_BINDIR@"));
    return installed;
}

inline QString docviewerDirectory()
{
    if (!SNAP_ENV.isEmpty()) {
        return SNAP_ENV + QString("@DATA_DIR@");
    } else if (isClick()) {
        return APP_DIR;
    } else if (isRunningInstalled()) {
        return QString("@DATA_DIR@");
    } else {
        return QString("@CMAKE_CURRENT_SOURCE_DIR@");
    }
}

inline QString i18nDirectory()
{
    if (!SNAP_ENV.isEmpty()) {
        return SNAP_ENV + QString("@CMAKE_INSTALL_FULL_LOCALEDIR@");
    } else if (isClick()) {
        return APP_DIR + QString("@CMAKE_INSTALL_FULL_LOCALEDIR@");
    } else if (isRunningInstalled()) {
        return QString("@CMAKE_INSTALL_FULL_LOCALEDIR@");
    } else {
        return QString("@CMAKE_CURRENT_SOURCE_DIR@");
    }
}
#endif // __CONFIG_H__
